#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#pragma comment(lib, "user32.lib")

const struct s2s_t {
    const char *name;
    int val;
} s2s[] = {
    {"SW_FORCEMINIMIZE", SW_FORCEMINIMIZE},
    {"SW_HIDE", SW_HIDE},
    {"SW_MAXIMIZE", SW_MAXIMIZE},
    {"SW_MINIMIZE", SW_MINIMIZE},
    {"SW_RESTORE", SW_RESTORE},
    {"SW_SHOW", SW_SHOW},
    {"SW_SHOWDEFAULT", SW_SHOWDEFAULT},
    {"SW_SHOWMAXIMIZED", SW_SHOWMAXIMIZED},
    {"SW_SHOWMINIMIZED", SW_SHOWMINIMIZED},
    {"SW_SHOWMINNOACTIVE", SW_SHOWMINNOACTIVE},
    {"SW_SHOWNA", SW_SHOWNA},
    {"SW_SHOWNOACTIVATE", SW_SHOWNOACTIVATE},
    {"SW_SHOWNORMAL", SW_SHOWNORMAL},
    {0, 0}
};

BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam) {
	char s[1024]; char *c = (char*)lParam;
	GetWindowText(hwnd, s, 1023);
    CharToOem(s, s);
	if (c? (strstr(s, c) != 0) : (strlen(s) != 0))
        printf("0x%08X: '%s'\n", hwnd, s);
	return true;
}

int main(int argc, char *argv[]) {
     bool has_l = 0;
     if (argc > 1 && !strncmp(argv[1], "-l", 2)) {
         char *c = argv[1] + 2;
         if (!*c) c = 0;
         else CharToOem(c, c);
         EnumWindows(EnumWindowsProc, (LPARAM)c);
         argc--, argv++;
         has_l = 1;
     }
     if (argc != 3) {
         if (has_l) return 0;
         fprintf(stderr, "Usage: ShowWindow [-l{substr}] HWND CmdShow\n  with -l to list existing windows and where CmdShow is one of the following:\n");
         for(const s2s_t *n = s2s; n->name; n++) printf("\t%s\n", n->name);
         return 1;
     }
     HWND hwnd = (HWND)strtoul(argv[1], 0, 0);
     if (!hwnd) { fprintf(stderr, "hwnd is null\n"); return 2; }
     int val;
     for(const s2s_t *n = s2s; n->name; n++) {
         if (!stricmp(argv[2], n->name)) { val = n->val; break; }
     }
     if (!n->name) {
         fprintf(stderr, "Unknown flag: '%s'\n", argv[2]);
         return 3;
     }
     printf("ShowWindow(0x%08X, %i)\n", hwnd, val);
     int rv = ShowWindow(hwnd, val);
     printf("returned %i (0x%08X)\n", rv, rv);
     return 0;
}
